Aria: ArRecurrentTask Class Reference

- Main Page
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# ArRecurrentTask Class Reference

`#include <ArRecurrentTask.h>`

Inheritance diagram for ArRecurrentTask:

List of all members.

## Detailed Description

Recurrent task (runs in its own thread).

The ArRecurrentTask is a task that runs in its own thread. Recurrent tasks are asynchronous tasks that complete in a finite amount of time, and need to be reinvoked recurrently. A typical example is Saphira's localization task: it runs for a few hundred milliseconds, localizes the robot, and returns. Then the cycle starts over. The user simply needs to derive their own class from ArRecurrentTask and define the task() function. This is the user code that will be called to execute the task body. Then, create an object of the class, and call the go() function to start the task. The status of the task can be checked with the done() function, which returns 0 if running, 1 if completed, and 2 if killed. go() can be called whenever the task is done to restart it. To stop the task in midstream, call reset(). kill() kills off the thread, shouldn't be used unless exiting the async task permanently

## Public Member Functions
| ArRecurrentTask ()
| Constructor.
int | done ()
| Check if the task is running or not.
void | go ()
| Starts up on cycle of the recurrent task.
void | kill ()
void | reset ()
| Cancel the task and reset for the next cycle.
void * | runThread (void *ptr)
virtual void | task ()=0
| The main run loop.
| ~ArRecurrentTask ()
| Descructor.

## Member Function Documentation

int ArRecurrentTask::done | ( |  | ) |

Check if the task is running or not.

0 = running, 1 = finished normally, 2 = canceled

virtual void ArRecurrentTask::task | ( |  | ) | `[pure virtual]`

The main run loop.

Override this function and put your task here.

The documentation for this class was generated from the following file:

- ArRecurrentTask.h